﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows;
using Infragistics;
using Infragistics.Controls.Charts;

namespace SilverlightApplication86
{
    public class TestData
        : ObservableCollection<TestDataItem>
    {
        private static Random _rand = new Random();

        public TestData()
        {
            double curr = 10.0;
            for (int i = 0; i < 100; i++)
            {
                if (_rand.NextDouble() < .5)
                {
                    curr += _rand.NextDouble() * 3.0;
                }
                else
                {
                    curr -= _rand.NextDouble() * 3.0;
                }

                Add(new TestDataItem()
                {
                    Column0 = i,
                    Column1 = curr + _rand.NextDouble() * 3.0,
                    Column2 = curr + _rand.NextDouble() * 3.0,
                    Column3 = curr - _rand.NextDouble() * 3.0,
                    Column4 = curr - _rand.NextDouble() * 3.0
                });
            }
        }
    }

    public class TestDataItem
    {
        public double Column0 { get; set; }
        public double Column1 { get; set; }
        public double Column2 { get; set; }
        public double Column3 { get; set; }
        public double Column4 { get; set; }
    }

    public class IntersectionFinder
        : IIntersectionFinder
    {
        FastReflectionHelper _helper = new FastReflectionHelper();
        public IList<Tuple<object, System.Windows.Point>> 
            GetIntersectedItemAxisItems(
            Series series,
            System.Windows.Point crosshairAxisPosition
            )
        {
            var intersections =
                new List<Tuple<object, Point>>();
            int index = 0;
            _helper.PropertyName = 
                ((AnchoredCategorySeries)series).ValueMemberPath;

            double prevX = double.NaN;
            double prevY = double.NaN;

            foreach (var item in series.ItemsSource.OfType<TestDataItem>())
            {
                double xVal = index;
                double yVal = 
                    Convert.ToDouble(_helper.GetPropertyValue(item));

                if (!double.IsNaN(xVal) &&
                    !double.IsNaN(yVal))
                {
                    if ((prevY < crosshairAxisPosition.Y &&
                        yVal >= crosshairAxisPosition.Y) ||
                        (prevY > crosshairAxisPosition.Y &&
                        yVal <= crosshairAxisPosition.Y))
                    {
                        intersections.Add(new Tuple<object,Point>(
                            item, new Point(xVal,yVal)));
                    }
                }

                index++;

                prevX = xVal;
                prevY = yVal;
            }

            return intersections;
        }
    }

}
