﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics;
using Infragistics.Controls.Charts;

namespace SilverlightApplication86
{
    public partial class XamDataChartHostControl : UserControl
    {
        private CursorTooltipBehavior curt;

        public XamDataChartHostControl()
        {
            InitializeComponent();
        }

        public XamDataChart XamDataChart
        {
            get
            {
                return wpfWebDataChart1;
            }
        }




        private void wpfWebDataChart1_SeriesCursorMouseMove(object sender, ChartCursorEventArgs e)
        {

            //CursorTooltipBehavior temp = new CursorTooltipBehavior();
            //temp.Chart_SeriesCursorMouseMove(sender, e);
            //if (e.Series != null && e.Item != null)
            //{
            //    curt.Chart_SeriesCursorMouseMove(sender , e );
            //}
        }




    }

    public class ChartBehaviors : DependencyObject
    {
        public static readonly DependencyProperty CursorTooltipProperty = DependencyProperty.RegisterAttached("CursorTooltip",
            typeof(CursorTooltipBehavior), typeof(ChartBehaviors), new PropertyMetadata(null, (o, e) => CursorTooltipChanged(o as XamDataChart, e.OldValue as CursorTooltipBehavior, e.NewValue as CursorTooltipBehavior)));

        public static CursorTooltipBehavior GetCursorTooltip(DependencyObject target)
        {
            return target.GetValue(CursorTooltipProperty) as CursorTooltipBehavior;
        }

        public static void SetCursorTooltip(DependencyObject target, CursorTooltipBehavior behavior)
        {
            target.SetValue(CursorTooltipProperty, behavior);
        }

        private static void CursorTooltipChanged(XamDataChart chart, CursorTooltipBehavior oldValue, CursorTooltipBehavior newValue)
        {
            if (chart == null)
            {
                return;
            }
            if (oldValue != null)
            {
                oldValue.OnDetach(chart);
            }
            if (newValue != null)
            {
                newValue.OnAttach(chart);
            }
        }
    }

    public class SeriesItemInfo : INotifyPropertyChanged
    {
        private Series _series;
        public Series Series
        {
            get { return _series; }
            set
            {
                _series = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Series"));
                    PropertyChanged(this, new PropertyChangedEventArgs("Value"));
                }
            }
        }

        private object _item;
        public object Item
        {
            get { return _item; }
            set
            {
                _item = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Item"));
                    PropertyChanged(this, new PropertyChangedEventArgs("Value"));
                }
            }
        }

        private Point _position;
        public Point Position
        {
            get { return _position; }
            set
            {
                _position = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(
                        this,
                        new PropertyChangedEventArgs("Position"));
                }
            }
        }


        private double _value;
        private FastReflectionHelper _helper = new FastReflectionHelper();

        public double Value
        {
            get
            {
                if (Series == null || Item == null)
                {
                    return 0.0;
                }
                if (Series is AnchoredCategorySeries)
                {
                    _helper.PropertyName =
                        ((AnchoredCategorySeries)Series)
                        .ValueMemberPath;

                    return Convert.ToDouble(_helper.GetPropertyValue(Item));
                }
                return 0.0;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class SeriesItemInfoCollection : ObservableCollection<SeriesItemInfo>
    {
        internal void UpdateSeriesItems(Series series, IList<Tuple<object, Point>> intersectedAxisItems)
        {
            bool found = false;
            var old = (from curr in this where curr.Series == series select curr).ToList();
            foreach (var item in old)
            {
                Remove(item);
            }

            foreach (var item in intersectedAxisItems)
            {
                Add(new SeriesItemInfo()
                {
                    Series = series,
                    Item = item.Item1,
                    Position = item.Item2
                });
            }
        }
    }

    public class PopupCollection
    {
        private XamDataChart _owner = null;
        private List<Popup> _popups = new List<Popup>();

        public PopupCollection(XamDataChart owner)
        {
            _owner = owner;
        }

        public void RefreshPopups(
            IList<SeriesItemInfo> infos,
            DataTemplate tooltipTemplate,
            Rect viewportRect)
        {
            int index = 0;
            foreach (var popup in _popups)
            {
                if (index >= infos.Count)
                {
                    break;
                }
                ContentControl control =
                    popup.Child as ContentControl;

                control.ContentTemplate = tooltipTemplate;
                control.Content = infos[index];

                UpdatePopupPosition(popup,
                    infos[index],
                    viewportRect);
                popup.IsOpen = true;

                index++;
            }

            for (int i = index; i < infos.Count; i++)
            {
                Popup popup = new Popup();
                popup.Child = new ContentControl();
                ContentControl control =
                   popup.Child as ContentControl;

                control.ContentTemplate = tooltipTemplate;
                control.Content = infos[i];

                UpdatePopupPosition(popup, infos[i], viewportRect);
                popup.IsOpen = true;

                Panel container;
                if (_owner.Parent != null && _owner.Parent is Panel)
                {
                    container = _owner.Parent as Panel;
                    container.Children.Add(popup);
                }
                _popups.Add(popup);

                index++;
            }

            for (int i = index; i < _popups.Count; i++)
            {
                _popups[i].IsOpen = false;
            }
        }

        private void UpdatePopupPosition(
            Popup popup,
            SeriesItemInfo info,
            Rect viewportRect)
        {
            double xPosition =
                ((AnchoredCategorySeries)info.Series).XAxis
                .GetScaledValue(
                info.Position.X,
                info.Series.Chart.WindowRect,
                viewportRect);
            double yPosition =
                ((AnchoredCategorySeries)info.Series).YAxis
                .GetScaledValue(
                info.Position.Y,
                info.Series.Chart.WindowRect,
                viewportRect);

            popup.HorizontalOffset = xPosition;
            popup.VerticalOffset = yPosition;
        }
    }

    public class CursorTooltipBehavior
    {
        private bool _isOverChart = false;
        private PopupCollection _popups = null;
        private ContentControl _content = new ContentControl();
        private Panel _container;
        private XamDataChart _owner = null;

        private DataTemplate _tooltipTemplate;

        private SeriesItemInfoCollection _items = new SeriesItemInfoCollection();

        public DataTemplate TooltipTemplate
        {
            get { return _tooltipTemplate; }
            set
            {
                _tooltipTemplate = value;
                _content.ContentTemplate = _tooltipTemplate;
            }
        }

        //protected bool IsOverChart
        //{
        //    get { return _isOverChart; }
        //    set
        //    {
        //        bool last = _isOverChart;
        //        _isOverChart = value;
        //        if (_isOverChart && !last)
        //        {
        //            ShowPopup();
        //        }
        //        if (!_isOverChart && last)
        //        {
        //            HidePopup();
        //        }
        //    }
        //}

        public void OnAttach(XamDataChart chart)
        {
            if (_owner != null)
            {
                OnDetach(_owner);
            }
            _owner = chart;
            chart.MouseLeave += Chart_MouseLeave;
            chart.MouseMove += Chart_MouseMove;
            //chart.SeriesCursorMouseMove += Chart_SeriesCursorMouseMove;
            chart.PropertyUpdated += Chart_PropertyUpdated;

            _popups = new PopupCollection(_owner);
        }

        void Chart_PropertyUpdated(object sender, PropertyUpdatedEventArgs e)
        {
            if (e.PropertyName == "CrosshairPoint")
            {
                if (e.NewValue != null &&
                    e.NewValue is Point &&
                    _owner != null)
                {
                    //get the relevant axes.   
                    CategoryXAxis x =
                        _owner.Axes.First((a) => a is CategoryXAxis)
                        as CategoryXAxis;
                    NumericYAxis y =
                        _owner.Axes.First((a) => a is NumericYAxis)
                        as NumericYAxis;

                    //determine the series viewport.   
                    Rect viewportRect = GetViewportRect(
                        _owner.Series[0],
                        x,
                        y);
                    Point p = (Point)e.NewValue;

                    double left;
                    double right;
                    double top;
                    double bottom;
                    GetInViewAxisBounds(x, y, viewportRect,
                        out left, out right,
                        out top, out bottom);

                    //get crosshair window values.   
                    double windowX =
                        (p.X - _owner.WindowRect.Left)
                        / _owner.WindowRect.Width;
                    double windowY =
                        (p.Y - _owner.WindowRect.Top)
                        / _owner.WindowRect.Height;

                    //interpolate axis values.   
                    double xAxisValue =
                        left + (windowX * (right - left));
                    double yAxisValue =
                        top + (windowY * (bottom - top));

                    if (!double.IsNaN(xAxisValue) &&
                        !double.IsNaN(yAxisValue) &&
                        IntersectionFinder != null)
                    {
                        foreach (var series in _owner.Series)
                        {
                            IList<Tuple<object, Point>> intersectedAxisItems =
                                IntersectionFinder.GetIntersectedItemAxisItems(
                                    series,
                                    new Point(xAxisValue, yAxisValue));

                            _items.UpdateSeriesItems(series, intersectedAxisItems);
                        }
                    }
                }
            }
        }

        public IIntersectionFinder IntersectionFinder { get; set; }

        private void GetInViewAxisBounds(
            CategoryXAxis x, NumericYAxis y,
            Rect viewportRect,
            out double left, out double right,
            out double top, out double bottom)
        {
            left = x.GetUnscaledValue(
                viewportRect.Left,
                _owner.WindowRect,
                viewportRect);
            right = x.GetUnscaledValue(
                viewportRect.Right,
                _owner.WindowRect,
                viewportRect);
            top = y.GetUnscaledValue(
                viewportRect.Top,
                _owner.WindowRect,
                viewportRect);
            bottom = y.GetUnscaledValue(
                viewportRect.Bottom,
                _owner.WindowRect,
                viewportRect);
        }

        private Rect GetViewportRect(
            Series target,
            CategoryXAxis x,
            NumericYAxis y)
        {
            double top = 0;
            double left = 0;
            double bottom = y.ActualHeight;
            double right = x.ActualWidth;
            double width = right - left;
            double height = bottom - top;

            if (width > 0.0 && height > 0.0)
            {
                return new Rect(left, top, width, height);
            }
            return Rect.Empty;
        }


        public void OnDetach(XamDataChart chart)
        {
            if (_owner != chart)
            {
                return;
            }
            chart.MouseLeave -= Chart_MouseLeave;
            chart.MouseMove -= Chart_MouseMove;
            //chart.SeriesCursorMouseMove -= Chart_SeriesCursorMouseMove;
            chart.PropertyUpdated -= Chart_PropertyUpdated;
            //IsOverChart = false;
            _items.Clear();
            _owner = null;
        }

        void Chart_MouseMove(object sender, MouseEventArgs e)
        {
            CategoryXAxis x =
                        _owner.Axes.First((a) => a is CategoryXAxis)
                        as CategoryXAxis;
            NumericYAxis y =
                _owner.Axes.First((a) => a is NumericYAxis)
                as NumericYAxis;

            //determine the series viewport.   
            Rect viewportRect = GetViewportRect(
                _owner.Series[0],
                x,
                y);
            _popups.RefreshPopups(_items, _tooltipTemplate, viewportRect);
            //IsOverChart = true;
        }

        //public void Chart_SeriesCursorMouseMove(object sender, ChartCursorEventArgs e)
        //{
        //    if (e.Series != null && e.Item != null)
        //    {
        //        _items.UpdateSeriesItem(e.Series, e.Item);
        //    }
        //}

        public void Chart_MouseLeave(object sender, MouseEventArgs e)
        {
            //IsOverChart = false;
        }
    }

    public interface IIntersectionFinder
    {
        IList<Tuple<object, Point>> GetIntersectedItemAxisItems(
            Series series,
            Point crosshairAxisPosition);
    }
}
